package nckd.base.helper;

import com.itrus.security.cert.X509Certificate;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.fileservice.FileServiceFactory;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.sdk.util.KHttpClientUtils;
import kd.bos.servicehelper.AttachmentDto;
import kd.bos.servicehelper.AttachmentServiceHelper;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import okhttp3.*;

import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;
import java.io.*;
import java.security.cert.CertificateException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class FileSECUtils {

    public static byte[] getFileTest() {

        String entryEntityName = "nckd_filetest";

//        DynamicObject billByn = BusinessDataServiceHelper.loadSingle(entryEntityName,
//                new QFilter[]{new QFilter("billno", QCP.equals, "test0001")});
//
//        List<Map<String, Object>> sourceFileList = AttachmentServiceHelper.getAttachments(entryEntityName,billByn.getPkValue(), "attachmentpanel");
//        Map<String, InputStream> files = new HashMap<>();
//
//        if(sourceFileList != null && sourceFileList.size()>0)
//        {
//            for(Map<String,Object> fileMap : sourceFileList){
//                //AttachmentDto attachmentDto = AttachmentServiceHelper.getAttachmentInfoByAttPk(fileMap.get("attPkId"));
//                //String fileUrl= attachmentDto.getResourcePath();
//                //String fileName = attachmentDto.getFilename();
//
//
//
//                System.out.println("fileUrl:" + fileUrl+ ",fileName:"+fileName);
//                ByteArrayOutputStream out = new ByteArrayOutputStream();
//                FileServiceFactory.getAttachmentFileService().download(fileUrl, out, null);
//                System.out.println("file:" + out.toByteArray());
//                return out.toByteArray();
//                //InputStream in = new ByteArrayInputStream(out.toByteArray());
//                //files.put(fileUrl,in);
//            }
//        }

        String filePath = "C:\\Users\\Administrator\\Desktop\\test.txt";
        try (InputStream inputStream = new FileInputStream(filePath)) {
            byte[] buffer = new byte[1024];
            int bytesRead;

            ByteArrayOutputStream outputStream = new ByteArrayOutputStream();

            while ((bytesRead = inputStream.read(buffer)) != -1) {
                outputStream.write(buffer, 0, bytesRead);
            }
            // 如果需要，可以在这里对 outputStream 进行额外操作
            // 例如：outputStream.flush();
            return outputStream.toByteArray();

        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    public static void postSECApi(){
        String url = "https://ebis.jeyoupharma.com:8443";
        Map<String, String> header = new HashMap<>();
        header.put("method-name", "checkFileIsEncryptionRest");

        TrustManager[] trustAllCerts = new TrustManager[]{
                new X509TrustManager() {

                    @Override
                    public void checkClientTrusted(java.security.cert.X509Certificate[] x509Certificates, String s) throws CertificateException {

                    }

                    @Override
                    public void checkServerTrusted(java.security.cert.X509Certificate[] x509Certificates, String s) throws CertificateException {

                    }

                    @Override
                    public X509Certificate[] getAcceptedIssuers() { return new X509Certificate[0]; }
                }
        };

        try {
            // 配置 SSLContext 使用不安全的 TrustManager
            SSLContext sslContext = SSLContext.getInstance("SSL");
            sslContext.init(null, trustAllCerts, new java.security.SecureRandom());

            //OkHttpClient client = new OkHttpClient();
            // 创建安全的 OkHttpClient
            // 创建 OkHttpClient 并禁用证书验证
            OkHttpClient insecureClient = new OkHttpClient.Builder()
                    .sslSocketFactory(sslContext.getSocketFactory(), (X509TrustManager) trustAllCerts[0])
                    .hostnameVerifier((hostname, session) -> true) // 绕过主机名验证
                    .build();

            // 创建 byte[] 类型的数据
            byte[] data = getFileTest();

            // 创建 RequestBody，设置媒体类型和 byte[] 数据
            //RequestBody requestBody = RequestBody.create(MediaType.get("application/octet-stream"), data);
            RequestBody requestBody = RequestBody.create(data, MediaType.get("application/octet-stream"));

            // 创建 Request 对象，设置目标 URL 和请求体
            Request request = new Request.Builder()
                    .url(url)
                    .post(requestBody)
                    .build();

            // 执行请求
            Response response = insecureClient.newCall(request).execute() ;
            // 获取响应状态码
            System.out.println("Status code: " + response.code());

            // 获取响应体并打印
            if (response.body() != null) {
                System.out.println("Response content: " + response.body().string());
            }
        } catch (IOException e) {
            e.printStackTrace();
            System.out.println("ERR content1: " + e.getMessage());
        } catch (Exception e1){
            e1.printStackTrace();
            System.out.println("ERR content2: " + e1.getMessage());
        }
    }

}
